#!/bin/bash

# ####################################################################
#
# All variables has the CQT_prefix
# BIN_PATH - are releative path to executable files of a deployed distribution.
# LIB_PATH - are releative path to libraryes of a deployed distribution.
# QML_PATH - are releative path to qml libraryes of a deployed distribution.
# PLUGIN_PATH - are releative path to qt plugins of a deployed distribution.
# BIN_PATH - are releative path to targets of a deployed distribution.

# SYSTEM_LIB_PATH - are releative path to system libraryes of a deployed distribution.
# BASE_NAME - are base name of the executable that will be launched after run this script.
# CUSTOM_SCRIPT_BLOCK - This is code from the customScript option
# RUN_COMMAND - This is command for run application. Requred BASE_DIR variable.
#
# ####################################################################


curuser=`whoami`
if [ "$curuser" = "root" ]; then
    echo "客户端进程不支持root用户"
    exit    
fi
echo "current user = $curuser"

PKG_NAME="com.xuanzsoft.xzprintclient"
PROCESS_NAME=XZPrintClient
ShellName=XZPrintClient.sh

# export XDG_RUNTIME_DIR=/usr/lib/
# export RUNLEVEL=3

BASE_DIR=$(dirname "$(readlink -f "$0")")
export PATH="$BASE_DIR"/bin/:$PATH
#export QML_IMPORT_PATH="$BASE_DIR"/qml/:$QML_IMPORT_PATH
#export QML2_IMPORT_PATH="$BASE_DIR"/qml/:$QML2_IMPORT_PATH
#export QT_PLUGIN_PATH="$BASE_DIR"/plugins/:$QT_PLUGIN_PATH
#export QTWEBENGINEPROCESS_PATH="$BASE_DIR"/bin/QtWebEngineProcess
#export QTDIR="$BASE_DIR"
#export CQT_PKG_ROOT="$BASE_DIR"
#export QT_QPA_PLATFORM_PLUGIN_PATH="$BASE_DIR"/plugins/platforms:$QT_QPA_PLATFORM_PLUGIN_PATH

curUserId=$(id -u ${curuser})
export DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/$curUserId/bus
export XDG_RUNTIME_DIR=/run/user/$curUserId
#qt的输入法环境变量
export QT_IM_MODULE=fcitx
#使用系统的 qt插件目录
#export QT_PLUGIN_PATH=/lib/x86_64-linux-gnu/qt5/plugins



ulimit -c unlimited
ulimit -n 65535


hasProcess()
{
    if [ "$1" = "" ]; then
        return 0
    fi

    # 只统计当前用户启动了多少个程序
    # wc 命令是统计行数, 而不是列数
    # grep -w 按照全词匹配
    process_num1=`ps -ef | grep -w "$1" | grep -v "grep" | grep -v "$ShellName"| grep -w "$curuser" | wc -l`
    # process_num1=`pidof "$1" |wc -l`

    echo "hasProcess = $process_num1"

    # 如果 $process_num1 为空, 则赋值为0
    if [[ -z "$process_num1" ]]; then
        process_num1=0
    fi


    if [ $process_num1 -ne 0 ]; then
        return 1
    else
        return 0
    fi
}

hasShellProcess()
{
    # grep -w 按照全词匹配
    process_num2=`ps -ef | grep -w "$ShellName" | grep -v "grep" | grep -w "$curuser" | wc -l`
    # process_num=`pidof "$1" |wc -l`

    echo "hasShellProcess $process_num2"

    # 如果 $process_num1 为空, 则赋值为0
    if [[ -z "$process_num2" ]]; then
        process_num2=0
    fi
    
    # 如果没有脚本在执行, 则该值为2, 猜测: 调用者bash 和当前的脚本, 所以算做2个进程
    if [ $process_num2 -gt 2 ]; then
        return 1
    else
        return 0
    fi
}

#hasShellProcess
#result1=$?
#if [ $result1 -eq 1 ]; then
#    echo "守护进程已启动, 不需要重复执行!"
#    exit
#fi

#echo "Daemon begin =========="

#因为要前面一些命令, 可能导致依赖混淆, 所以依赖目录放到这里定义
export LD_LIBRARY_PATH="$BASE_DIR/lib/":"$BASE_DIR/lib/x86_64-linux-gnu":"$BASE_DIR":$LD_LIBRARY_PATH

#while [ 1 ] ; do
    hasProcess $PROCESS_NAME
    result2=$?

    if [ $result2 -eq 0 ]; then
        echo "start XZPrintClient..."
        "$BASE_DIR/bin/XZPrintClient" &
    else
        echo result2 = $result2
    fi

#    sleep 3
#done

#echo "Daemon end =========="